/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomNamedNodeMap_H__
#define __GdomNamedNodeMap_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomNamedNodeMap GdomNamedNodeMap;
typedef struct _GdomNamedNodeMapClass GdomNamedNodeMapClass;


#define GDOM_TYPE_NAMED_NODE_MAP            (gdom_named_node_map_get_type())
#define GDOM_NAMED_NODE_MAP(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_NAMED_NODE_MAP, GdomNamedNodeMap))
#define GDOM_NAMED_NODE_MAP_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_NAMED_NODE_MAP, GdomNamedNodeMap)Class)
#define GDOM_IS_NAMED_NODE_MAP(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_NAMED_NODE_MAP))
#define GDOM_IS_NAMED_NODE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_NAMED_NODE_MAP))
#define GDOM_NAMED_NODE_MAP_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_NAMED_NODE_MAP, GdomNamedNodeMapClass))

typedef struct _GdomNamedNodeMapPrivate GdomNamedNodeMapPrivate;

struct _GdomNamedNodeMap {
    GdomDOMObject parent_instance;
    GdomNamedNodeMapPrivate *priv;
};

struct _GdomNamedNodeMapClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_named_node_map_get_type (void);

WEBKIT_API GdomNode *
gdom_named_node_map_get_named_item (GdomNamedNodeMap *thiz, gchar * name);

WEBKIT_API GdomNode *
gdom_named_node_map_set_named_item (GdomNamedNodeMap *thiz, GdomNode * node);

WEBKIT_API GdomNode *
gdom_named_node_map_remove_named_item (GdomNamedNodeMap *thiz, gchar * name);

WEBKIT_API GdomNode *
gdom_named_node_map_item (GdomNamedNodeMap *thiz, gulong index);

WEBKIT_API GdomNode *
gdom_named_node_map_get_named_item_ns (GdomNamedNodeMap *thiz, gchar * namespace_uri, gchar * local_name);

WEBKIT_API GdomNode *
gdom_named_node_map_set_named_item_ns (GdomNamedNodeMap *thiz, GdomNode * node);

WEBKIT_API GdomNode *
gdom_named_node_map_remove_named_item_ns (GdomNamedNodeMap *thiz, gchar * namespace_uri, gchar * local_name);

G_END_DECLS

#endif /* __GdomNamedNodeMap_H__ */
